package com.jd.aof.features.virgo.wx;

import com.jd.aof.features.virgo.wx.generateClickPayData..anonfun.1;
import com.jd.aof.features.virgo.wx.generateClickPayData..anonfun.2;
import com.jd.aof.features.virgo.wx.generateClickPayData..anonfun.3;
import com.jd.aof.features.virgo.wx.generateClickPayData..anonfun.4;
import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.PosixParser;
import org.apache.spark.sql.Column;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.SparkSession;
import org.apache.spark.sql.expressions.WindowSpec;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import scala.StringContext;
import scala.collection.Seq;
import scala.collection.immutable.StringOps;
import scala.util.Try.;

public final class generateClickPayData$ {

   public static final generateClickPayData$ MODULE$;
   private final Logger logger;
   private final SparkSession spark;


   static {
      new generateClickPayData$();
   }

   public Logger logger() {
      return this.logger;
   }

   public SparkSession spark() {
      return this.spark;
   }

   public void main(String[] args) {
      CommandLine cli = this.parseArgs2Cli(args);
      String cur_date = (String).MODULE$.apply(new 1(cli)).getOrElse(new 2());
      String aof_db = (String).MODULE$.apply(new 3(cli)).getOrElse(new 4());
      this.logger().info((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |Input args:\n         |-----------------------------------\n         |cur_date: ", ",\n         |aof_db: ", "\n         |-----------------------------------\n       "})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{cur_date, aof_db}))))).stripMargin());
      if(cur_date != null && aof_db != null) {
         this.run(cur_date, aof_db);
      } else {
         throw new RuntimeException("Some parameter was not set, check your input args!");
      }
   }

   public void run(String cur_date, String aof_db) {
      Dataset base50 = this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |select\n         |  parent_order_id,\n         |  order_detail_id,\n         |  order_id,\n         |  sku_id,\n         |  vendor_id,\n         |  user_pin,\n         |  ordering_time,\n         |  payment_time,\n         |  item_category_1_code,\n         |  item_category_2_code,\n         |  item_category_3_code,\n         |  before_prefr_price,\n         |  after_prefr_price,\n         |  after_prefr_amount_1,\n         |  super_red_packet_amount,\n         |  gift_card_pay_amount,\n         |  if(substr(order_flags, 87, 1) == \'2\', 1, 0) as if_wq_friend_pay\n         |from\n         |  aof.aof_rigel_base_orders_50d\n         |where\n         |  dt == \'", "\'\n         |  and ordering_date >= \'", "\'\n         |  and ordering_date <= \'", "\'\n         |  and order_split_code != \'1\'\n         |  and order_valid_flag == \'1\'\n         |  and outbound_time is not null and trim(outbound_time) != \'\'\n         |  and order_category_code == \'20\'\n         |"})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{cur_date, cur_date, cur_date}))))).stripMargin()).distinct();
      Dataset click_data = this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |select\n         |  clstag as event_id,\n         |  page_mod,\n         |  page_name,\n         |  trim(lower(user_log_acct)) as user_pin,\n         |  request_tm\n         |from\n         |  adm.adm_m14_ol_click_log\n         |where\n         |  dt == \'", "\'\n         |"})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{cur_date}))))).stripMargin()).distinct();
      Dataset cls_name = this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString("\n        |select\n        |  event_id,\n        |  event_name,\n        |  module,\n        |  row_number() over(partition by event_id order by ver desc, vid desc) as rank\n        |from\n        |  dim.dim_wireless_event_id\n        |"))).stripMargin()).distinct().filter("rank = 1").select("event_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"event_name", "module"})));
      Dataset click_union = click_data.join(cls_name, (Seq)scala.collection.Seq..MODULE$.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"event_id"}))), "inner").distinct();
      Dataset pay_online = this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |select\n         |  trim(lower(pin)) as user_pin,\n         |  outbizno as outbizno1,\n         |  paymoney, -- 支付金额\n         |  cardtype, -- 卡类型\n         |  paytime,\n         |  payenum, -- 枚举值\n         |  paytype, -- 支付类型\n         |  payorderattr, --支付方式\n         |  payid, -- 支付单\n         |  cardid\n         |from\n         |  fdm.fdm_paytrade_02_payresult_chain\n         |where\n         |  dp=\'ACTIVE\'\n         |  and substr(createtime, 1, 10) >= \'", "\'\n         |  and substr(createtime, 1, 10) <= \'", "\'\n         |"})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{cur_date, cur_date}))))).stripMargin()).distinct();
      Dataset paytrade_orderid_add = this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |select\n         |  payid,\n         |  outbizno as outbizno2\n         |from\n         |  fdm.fdm_paytrade_02_paymerchantorder_chain\n         |where\n         |  dp=\'ACTIVE\'\n         |  and substr(createtime, 1, 10) >= \'", "\'\n         |  and substr(createtime, 1, 10) <= \'", "\'\n         |"})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{cur_date, cur_date}))))).stripMargin());
      Dataset dim_pay_enum_cd_new = this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |select\n         |  dim_pay_enum_cd as payenum,\n         |  pay_enum_desc\n         |from\n         |  dim.dim_pay_enum_cd_new\n         |"})))).s(scala.collection.immutable.Nil..MODULE$)))).stripMargin()).groupBy("payenum", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[0]))).agg(org.apache.spark.sql.functions..MODULE$.max("pay_enum_desc").as("pay_enum_desc"), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0])));
      Dataset pay_online_full = pay_online.join(paytrade_orderid_add, (Seq)scala.collection.Seq..MODULE$.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"payid"}))), "left").join(dim_pay_enum_cd_new, (Seq)scala.collection.Seq..MODULE$.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"payenum"}))), "left").selectExpr(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"if(outbizno1 is null, outbizno2, outbizno1) as parent_order_id", "user_pin", "payenum", "pay_enum_desc", "paymoney", "cardtype", "paytime", "paytype", "payorderattr", "payid", "cardid"}))).distinct();
      Dataset orders = base50.join(pay_online_full, (Seq)scala.collection.Seq..MODULE$.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"parent_order_id", "user_pin"}))), "left").distinct().cache();
      Dataset base = orders.join(click_union, (Seq)scala.collection.Seq..MODULE$.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"user_pin"}))), "left").distinct().cache();
      WindowSpec windowSpec = org.apache.spark.sql.expressions.Window..MODULE$.partitionBy("order_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[0]))).orderBy(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{org.apache.spark.sql.functions..MODULE$.desc("ordering_time")})));
      Dataset daifu_order = base.filter("event_name like \'%代付%\'").filter("ordering_time <= request_tm").withColumn("row_number", org.apache.spark.sql.functions..MODULE$.row_number().over(windowSpec)).filter("row_number == 1").selectExpr(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"1 as is_daifu_order", "order_detail_id", "order_id", "sku_id"}))).distinct();
      daifu_order.createOrReplaceTempView("daifu_order");
      this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |CREATE TABLE IF NOT EXISTS ", ".aof_click_pay_info\n         |(\n         |  order_detail_id                          STRING COMMENT \'order_detail_id\',\n         |  order_id                                 STRING COMMENT \'order_id\',\n         |  sku_id                                   STRING COMMENT \'sku_id\',\n         |  is_daifu_order                           STRING COMMENT \'是否好友代付\'\n         |)\n         |PARTITIONED BY\n         |(\n         |  dt                                    STRING\n         |)\n         |STORED AS ORC\n         |"})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{aof_db}))))).stripMargin());
      this.spark().sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"\n         |INSERT\n         |  overwrite TABLE ", ".aof_click_pay_info partition\n         |  (\n         |    dt=\'", "\'\n         |  )\n         |SELECT\n         |  order_detail_id,\n         |  order_id,\n         |  sku_id,\n         |  is_daifu_order\n         |FROM daifu_order\n         |"})))).s(scala.Predef..MODULE$.genericWrapArray(new Object[]{aof_db, cur_date}))))).stripMargin());
   }

   public CommandLine parseArgs2Cli(String[] args) {
      try {
         Options options = (new Options()).addOption((String)null, "cur_date", true, "cur_date").addOption((String)null, "aof_db", true, "aof_db");
         return (new PosixParser()).parse(options, args);
      } catch (Throwable var5) {
         var5.printStackTrace();
         throw new Error("Failed to parse command line options.");
      }
   }

   private generateClickPayData$() {
      MODULE$ = this;
      this.logger = LoggerFactory.getLogger(this.getClass());
      this.spark = com.jd.aof.features.common.SparkEnvironment..MODULE$.getSparkSession();
   }
}
